/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_DONNEES_SELECTIONPAGE__
#define __INVESTIGATION_DONNEES_SELECTIONPAGE__

#include <vector>
#include <src/global/global.h>
namespace Investigation { namespace Donnees { DECL_SHARED_PTR(SelectionPage); } }
#include <src/investigation/donnees/instruction.h>
#include <src/investigation/donnees/selection.h>

namespace Investigation
{
	namespace Donnees
	{
		class SelectionPage : public Instruction, public Selection<Instruction>
		{
			public:
				explicit SelectionPage(const typename Selection<Instruction>::SequenceClauses& clauses, const SequenceInstructions& clause_par_defaut, const Investigation::Global::Source::PositionSP& position);
				virtual ~SelectionPage();
				virtual Investigation::Donnees::SequencePages operator() (const Investigation::Donnees::Requete& requete) const;
				virtual InstructionSP clone() const;
				virtual std::set<std::string> operator[] (const Investigation::Donnees::Requete& requete);
				virtual bool operator%(const Instruction& instruction) const;
				bool operator%(const SelectionPage& page) const;
				virtual std::set<std::string> identifiants() const;
				virtual void liens_valides(const std::set<std::string>& identifiants) const;
				virtual void propage_infos();
				virtual void compte(CompteursSite& compteurs) const ;
			private:
				SelectionPage(const Selection<Instruction>& selection, const Investigation::Global::Source::PositionSP& position);
		};
	}
}
#endif
