/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#include <src/investigation/donnees/texte.h>

#include <src/investigation/donnees/html.h>
using namespace Investigation::Donnees;

Texte::Texte(const std::string& texte)
	:_texte(texte) { }
Texte::~Texte() {}
Html::SequenceContenuDiv Texte::operator() (const std::string& methode, const Requete& requete, Liens& liens) const
{
	Html::P texte("investigation page text");
	texte << _texte;
	Html::SequenceContenuDiv seq;
	seq.push_back(texte);
	return seq;
}
ContenuPageSP Texte::clone() const
{
	ContenuPageSP texte(new Texte(_texte));
	return texte;
}
bool Texte::operator%(const ContenuPage& contenu_page) const
{
	const Texte& texte=dynamic_cast<const Texte&>(contenu_page); // throw bad_cast
	return (*this)%(texte);
}
bool Texte::operator%(const Texte& texte) const
{
	return true;
}
void Texte::liens_valides(const std::set<std::string>& identifiants) const
{
}
void Texte::propage_infos(const std::string& page)
{
}
long int Texte::niveau_information() const
{
	return 1;
}
void Texte::compte(CompteursSite& compteurs) const
{
}
